#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
#
###2004-0327 - Modded by catastrophe for use with Bandview v.0.1
###2004-0328 - Modded by catastrophe for use with Bandview v.0.2
# - Check for "Monthly ipacsum Usage mod" by Unicorn, if exists then Bandview entry not added to crontab
###2004-0331 - Modded by catastrophe for use with Bandview v.0.3
###2004-0421 - Modded by catastrophe for use with Bandview v.0.4


# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

print "\nUninstalling Bandview v.0.5, please wait...\n";

if (&installed ("/var/smoothwall/langs/base.pl", "# bandview v.0.4")) {
	print " \nPlease remove Bandview pack v.0.4\n ";
	print "Note - Run uninstall-04.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# bandview v.0.3")) {
	print " \nPlease remove Bandview pack v.0.3\n ";
	print "Note - Run uninstall-03.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# bandview v.0.2")) {
	print " \nPlease remove Bandview pack v.0.2.x\n ";
	print "Note - Run uninstall-02.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# bandview v.0.1")) {
	print " \nPlease remove Bandview pack v.0.11\n ";
	print "Note - Run uninstall-011.pl script.\n \n";
	exit;
}

if (&installed ("/home/httpd/cgi-bin/graphs.cgi", "<TD WIDTH='10%' CLASS='base'>Anniversary Day</TD>")) {
	print "Setup detects the Monthly ipacsum Usage mod by Unicorn exists\n ";
	print "Note - Bandview shares similar files and utilizes the same crontab entries\n \n";
} elsif (&installed ("/etc/crontab", "# update the script /usr/local/bin/thisperiod.sh once a day.")) {
	print "Setup detects the Monthly ipacsum Usage mod by Unicorn exists\n ";
	print "Note - Bandview shares similar files and utilizes the same crontab entries\n \n";
} elsif (&installed ("/etc/crontab", "# update the script /usr/local/bin/thisperiod.sh once a day. ")) {
	print "Setup detects the Monthly ipacsum Usage mod by Unicorn exists\n ";
	print "Note - Bandview shares similar files and utilizes the same crontab entries\n \n";
} elsif (&installed ("/etc/crontab", "# updated usage this period every 30 minutes")) {
	print "Setup detects the Monthly ipacsum Usage mod by Unicorn exists\n ";
	print "Note - Bandview shares similar files and utilizes the same crontab entries\n \n";
} elsif (&installed ("/etc/crontab", "# updated usage this period every 30 minutes ")) {
	print "Setup detects the Monthly ipacsum Usage mod by Unicorn exists\n ";
	print "Note - Bandview shares similar files and utilizes the same crontab entries\n \n";
}

# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file ,$wkdir ,$storebkp ,$moddir);
#	backup ($file ,$wkdir ,$storebkp);
#	install ($file ,$wkdir ,$moddir);
#	uninstallrestore ($file ,$wkdir ,$storebkp);
#	uninstall ($file  ,$wkdir);

my $bkp = '/var/smoothwall/mods/bandview/backup';

my $mod = '/var/smoothwall/mods/bandview/modfiles';

$dir = '/home/httpd/cgi-bin';
#&uninstallrestore ('bandview.cgi' ,$dir ,$bkp);
&uninstall ('bandview.cgi' ,$dir);

$dir = '/home/httpd/html/help';
#&uninstallrestore ('bandview.cgi.html.en' ,$dir ,$bkp);
&uninstall ('bandview.cgi.html.en' ,$dir);

$dir = '/usr/local/bin';
#&uninstallrestore ('bandview.pl' ,$dir ,$bkp);
&uninstall ('bandview.pl' ,$dir);

$dir = '/usr/local/bin'; 
#&uninstallrestore ('thisperiod.sh' ,$dir ,$bkp);
#&uninstall ('thisperiod.sh' ,$dir);

$dir = '/usr/local/bin'; 
#&uninstallrestore ('usage.dat' ,$dir ,$bkp);
#&uninstall ('usage.dat' ,$dir);

$dir = '/var/lib/ipac'; 
#&uninstallrestore ('usage.pl' ,$dir ,$bkp);
#&uninstall ('ipacsum.thisperiod.stats' ,$dir);

$dir = '/usr/local/bin'; 
#&uninstallrestore ('usage.pl' ,$dir ,$bkp);
if (&installed ("/home/httpd/cgi-bin/graphs.cgi", "<TD WIDTH='10%' CLASS='base'>Anniversary Day</TD>")) {
	print "Setup did not remove /usr/local/bin/usage.pl\n ";
	print "Note - It is still required for use with the Monthly ipacsum Usage mod by Unicorn.\n \n";
} elsif (&installed ("/etc/crontab", "# update the script /usr/local/bin/thisperiod.sh once a day.")) {
	print "Setup did not remove /usr/local/bin/usage.pl\n ";
	print "Note - It is still required for use with the Monthly ipacsum Usage mod by Unicorn.\n \n";
} elsif (&installed ("/etc/crontab", "# update the script /usr/local/bin/thisperiod.sh once a day. ")) {
	print "Setup did not remove /usr/local/bin/usage.pl\n ";
	print "Note - It is still required for use with the Monthly ipacsum Usage mod by Unicorn.\n \n";
} elsif (&installed ("/etc/crontab", "# updated usage this period every 30 minutes")) {
	print "Setup did not remove /usr/local/bin/usage.pl\n ";
	print "Note - It is still required for use with the Monthly ipacsum Usage mod by Unicorn.\n \n";
} elsif (&installed ("/etc/crontab", "# updated usage this period every 30 minutes ")) {
	print "Setup did not remove /usr/local/bin/usage.pl\n ";
	print "Note - It is still required for use with the Monthly ipacsum Usage mod by Unicorn.\n \n";
} else {
       &uninstall ('usage.pl' ,$dir);
}



# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

my $param = '/var/smoothwall/mods/bandview/params';

&easymod ("/var/smoothwall/main/ui/alertboxes.en.pl", "$param/alertboxes.en.pl.05.d",'2',"/dev/null");

&easymod ("/var/smoothwall/langs/base.pl", "$param/base.pl.05.d",'16',"/dev/null");

&easymod ("/var/smoothwall/header.pl", "$param/header.pl.01.d",'1',"/dev/null");

&easymod ("/home/httpd/cgi-bin/.htaccess", "$param/htaccess.01.d",'3',"/dev/null");

&easymod ("/etc/crontab", "$param/crontab.05.d",'4',"/dev/null");

#&easymod ("/var/smoothwall/header.pl", "$param/mods.pl.01.d",'1',"/dev/null");

# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #

system '/bin/rm -f /home/httpd/html/ui/assets/3.6/img/pagetitles/page-bandview.png';

# # # #
# end #
# # # #

#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal

$version = '2.1';

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file ,$wkdir ,$storebkp ,$moddir);
#	backup ($file ,$wkdir ,$storebkp);
#	install ($file ,$wkdir ,$moddir);
#	uninstallrestore ($file ,$wkdir ,$storebkp);
#	uninstall ($file  ,$wkdir);

sub backupinstall
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	my $moddir = $_[3];
#	system "/bin/cp -p $wkdir/$file $storebkp/$file";
#	system "/bin/cp $moddir/$file $wkdir/$file";
	system "/bin/cp -p $moddir/$file $wkdir/$file";
}

sub backup
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	system "/bin/cp -p $wkdir/$file $storebkp/$file";
}

sub install
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $moddir = $_[2];
	system "/bin/cp -p $moddir/$file $wkdir/$file";
}

sub uninstallrestore
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	system "/bin/cp -p $storebkp/$file $wkdir/$file";
#	system "/bin/rm -f $storebkp/$file";
}

sub uninstall
{
	my $file = $_[0];
	my $wkdir = $_[1];
	system "/bin/rm -f $wkdir/$file";
}

sub easymod
{
	my $targetfile = $_[0];
	my $searchfile = $_[1];
	my $linestodelete = $_[2];
	my $replacefile = $_[3];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	open(SEARCH, "$searchfile") or die 'Unable to open search file';
	my @search = <SEARCH>;
	close(SEARCH);

	open(REPLACE, "$replacefile") or die 'Unable to open replace file.';
	my @replace = <REPLACE>;
	close(REPLACE);

	open(TEMP, ">/tmp/temp") or die 'Unable to open temporary file.';
	flock TEMP, 2;

	my $found = 0;
	my $line;
	foreach $line (@target)
	{
		if ($found == 0)
		{
			if ($line eq "@search")
			{
				$found = 1;
				if ($linestodelete > 0)
				{
					$linestodelete--;
				}
				else {print TEMP "$line"; }
				my $repline;
				foreach $repline (@replace) {print TEMP $repline; }
			}
			else {print TEMP "$line"; }
		}
		else
		{
			if ($linestodelete > 0)
			{
				$linestodelete--;
			}
			else {print TEMP "$line"; }
		}
	}	
	close(TEMP);
	system "/bin/cp /tmp/temp $targetfile";
	system "/bin/rm -f /tmp/temp";
}

sub installed
{
	my $targetfile = $_[0];
	my $searchstring = $_[1];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	my $line;
	foreach $line (@target)
	{
		if ($line eq "$searchstring\n")
		{
			return 1;
		}
	}	
	return 0;
}
