#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
#
###2004-0327 - Modded by catastrophe for use with Bandview v.0.1
###2004-0328 - Modded by catastrophe for use with Bandview v.0.2
# - Check for "Monthly ipacsum Usage mod" by Unicorn, if exists then Bandview entry not added to crontab
###2004-0331 - Modded by catastrophe for use with Bandview v.0.3
###2004-0421 - Modded by catastrophe for use with Bandview v.0.4
###2004-0728 - Modded by catastrophe for use with Bandview v.0.5
###2004-1123 - Modded by catastrophe for use with Bandview v.0.5.2
###2004-1130 - Modded by catastrophe for use with Bandview v.0.6
###2004-1215 - Modded by catastrophe for use with Bandview v.0.6.1
###2005-0310 - Modded by catastrophe for use with Bandview v.0.6.2


# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

print "\nInstalling Bandview v.0.6.2, please wait...\n\n";

if (&installed ("/var/smoothwall/langs/base.pl", "# bandview v.0.6.2")) {
	print "Please remove Bandview pack v.0.6.2\n ";
	print "Note - Run uninstall.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# bandview v.0.6")) {
	print "Please remove Bandview pack v.0.6 or v.0.6.1\n ";
	print "Note - Run uninstall-06.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# bandview v.0.5.2")) {
	print "Please remove Bandview pack v.0.5.2\n ";
	print "Note - Run uninstall-052.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# bandview v.0.5")) {
	print "Please remove Bandview pack v.0.5\n ";
	print "Note - Run uninstall-05.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# bandview v.0.4")) {
	print "Please remove Bandview pack v.0.4\n ";
	print "Note - Run uninstall-04.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# bandview v.0.3")) {
	print "Please remove Bandview pack v.0.3\n ";
	print "Note - Run uninstall-03.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# bandview v.0.2")) {
	print "Please remove Bandview pack v.0.2.x\n ";
	print "Note - Run uninstall-02.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# bandview v.0.1")) {
	print "Please remove Bandview pack v.0.1.1\n ";
	print "Note - Run uninstall-011.pl script.\n \n";
	exit;
}

if (&installed ("/home/httpd/cgi-bin/graphs.cgi", "<TD WIDTH='10%' CLASS='base'>Anniversary Day</TD>")) {
	print "Setup detects the Monthly ipacsum Usage mod by Unicorn exists\n ";
	print "Note - Bandview shares similar files and utilizes the same crontab entries\n \n";
} elsif (&installed ("/etc/crontab", "# update the script /usr/local/bin/thisperiod.sh once a day.")) {
	print " \nSetup detects the Monthly ipacsum Usage mod by Unicorn exists\n ";
	print "Note - Bandview shares similar files and utilizes the same crontab entries\n \n";
} elsif (&installed ("/etc/crontab", "# update the script /usr/local/bin/thisperiod.sh once a day. ")) {
	print " \nSetup detects the Monthly ipacsum Usage mod by Unicorn exists\n ";
	print "Note - Bandview shares similar files and utilizes the same crontab entries\n \n";
} elsif (&installed ("/etc/crontab", "# updated usage this period every 30 minutes")) {
	print " \nSetup detects the Monthly ipacsum Usage mod by Unicorn exists\n ";
	print "Note - Bandview shares similar files and utilizes the same crontab entries\n \n";
} elsif (&installed ("/etc/crontab", "# updated usage this period every 30 minutes ")) {
	print " \nSetup detects the Monthly ipacsum Usage mod by Unicorn exists\n ";
	print "Note - Bandview shares similar files and utilizes the same crontab entries\n \n";
}

# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	backupinstall ($file ,$wkdir ,$storebkp ,$moddir);
#	install ($file ,$wkdir ,$moddir);

my $bkp = '/var/smoothwall/mods/bandview/backup';

my $mod = '/var/smoothwall/mods/bandview/modfiles';

$dir = '/home/httpd/cgi-bin';
#&backupinstall ('bandview.cgi' ,$dir ,$bkp ,$mod);
&install ('bandview.cgi' ,$dir ,$mod);

$dir = '/home/httpd/html/help';
#&backupinstall ('bandview.cgi.html.en' ,$dir ,$bkp ,$mod);
&install ('bandview.cgi.html.en' ,$dir ,$mod);

$dir = '/usr/local/bin';
#&backupinstall ('bandview.pl' ,$dir ,$bkp ,$mod);
&install ('bandview.pl' ,$dir ,$mod);

$dir = '/usr/local/bin';
#&backupinstall ('bandviewhelper' ,$dir ,$bkp ,$mod);
&install ('bandviewhelper' ,$dir ,$mod);

$dir = '/usr/local/bin'; 
#&backupinstall ('usage.dat' ,$dir ,$bkp ,$mod);
if (&installed ("/home/httpd/cgi-bin/graphs.cgi", "usage.dat")) {
       &backup ('usage.dat' ,$dir ,$bkp);
       print "Backup of $dir/usage.dat stored as $bkp/backup.dat \n";
} elsif (&installed ("/etc/crontab", "thisperiod.sh")) {
       &backup ('usage.dat' ,$dir ,$bkp);
       print "Backup of $dir/usage.dat stored as $bkp/backup.dat \n";
}
&install ('usage.dat' ,$dir ,$mod);

$dir = '/usr/local/bin'; 
#&backupinstall ('usage.pl' ,$dir ,$bkp ,$mod);
&install ('usage.pl' ,$dir ,$mod);

$dir = '/etc';
&backup ('crontab' ,$dir ,$bkp);
print "Backup of $dir/crontab stored as $bkp/crontab \n\n";

$dir = '/etc/rc.d/helper';
&backup ('writeipac.pl' ,$dir ,$bkp ,$mod);
print "Backup of $dir/writeipac.pl stored as $bkp/writeipac.pl \n\n";

if (-e "/var/smoothwall/preferences/bandview-userlist") {	###avoid preferences & userlist incompatibilities
	$dir = '/var/smoothwall/preferences';
	&backup ('bandview' ,$dir ,$bkp);
#	&uninstall ('bandview' ,$dir ,$bkp);
	&backup ('bandview2' ,$dir ,$bkp);
#	&uninstall ('bandview2' ,$dir ,$bkp);
	&backup ('bandview4' ,$dir ,$bkp);
#	&uninstall ('bandview4' ,$dir ,$bkp);
	&backup ('bandview-userlist' ,$dir ,$bkp);
#	&uninstall ('bandview-userlist' ,$dir ,$bkp);
	print "Backup of $dir/bandview-userlist stored as $bkp/bandview-userlist \n\n";
#	system ("/usr/local/bin/bandviewhelper");
}

# remove these lines when the web UI interface is ready
open (FILE, ">/var/smoothwall/preferences/dummy") or system ("/bin/su nobody -c '/bin/mkdir /var/smoothwall/preferences'");
close (FILE);
system ("/bin/rm -f /var/smoothwall/preferences/dummy");

# uncomment these lines when the web UI interface is ready
#open (FILE, ">/var/smoothwall/preferences/dummy") or system ("/bin/mkdir /var/smoothwall/preferences");
#close (FILE);
#system ("/bin/rm -f /var/smoothwall/preferences/dummy");

# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

my $param = '/var/smoothwall/mods/bandview/params';

&easymod ("/var/smoothwall/main/ui/alertboxes.en.pl", "$param/alertboxes.en.pl.05.s",'0',"$param/alertboxes.en.pl.05.r");

&easymod ("/var/smoothwall/langs/base.pl", "$param/base.pl.06.s",'0',"$param/base.pl.062.r");

&easymod ("/var/smoothwall/header.pl", "$param/header.pl.06.s",'0',"$param/header.pl.06.r");

&easymod ("/home/httpd/cgi-bin/.htaccess", "$param/htaccess.01.s",'3',"$param/htaccess.01.r");

if (&installed ("/etc/crontab", "# update the script /usr/local/bin/thisperiod.sh once a day.")) {
	print "Setup detects that thisperiod.sh already exists in /etc/crontab\n ";
	print "Note - Setup will not add thisperiod.sh or usage.pl /etc/crontab\n ";
	print "Note - If this was done in error, please add them manually to crontab\n \n";
} elsif (&installed ("/etc/crontab", "# update the script /usr/local/bin/thisperiod.sh once a day. ")) {
	print "Setup detects that an entry for thisperiod.sh already exists in /etc/crontab\n ";
	print "Note - Setup will not add thisperiod.sh or usage.pl /etc/crontab\n ";
	print "Note - If this was done in error, please add them manually to crontab\n \n";
} elsif (&installed ("/etc/crontab", "# updated usage this period every 30 minutes")) {
	print "Setup detects that an entry for usage.pl already exists in /etc/crontab\n ";
	print "Note - Setup will not add thisperiod.sh or usage.pl /etc/crontab\n ";
	print "Note - If this was done in error, please add them manually to crontab\n \n";
} elsif (&installed ("/etc/crontab", "# updated usage this period every 30 minutes ")) {
	print "Setup detects that an entry for usage.pl already exists in /etc/crontab\n ";
	print "Note - Setup will not add thisperiod.sh or usage.pl /etc/crontab\n ";
	print "Note - If this was done in error, please add them manually to crontab\n \n";
} else {
&easymod ("/etc/crontab", "$param/crontab.06.s",'0',"$param/crontab.062.r"); 
}

&easymod ("/etc/rc.d/helper/writeipac.pl", "$param/writeipac.pl.06.s",'1',"$param/writeipac.pl.062.r");

if (-e "/var/smoothwall/preferences/bandview-userlist") {	###add user monitoring rules
	print "/var/smoothwall/preferences/bandview-userlist exists... Activating user monitoring rules.\n";
	system ("/usr/local/bin/bandviewhelper");
}

# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #

system '/bin/ln -s /home/httpd/html/ui/assets/3.6/img/pagetitles/title-about.png /home/httpd/html/ui/assets/3.6/img/pagetitles/page-bandview.png';

# # # #
# end #
# # # #

#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal

$version = '2.1';

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file ,$wkdir ,$storebkp ,$moddir);
#	backup ($file ,$wkdir ,$storebkp);
#	install ($file ,$wkdir ,$moddir);
#	uninstallrestore ($file ,$wkdir ,$storebkp);
#	uninstall ($file  ,$wkdir);
#
#	installed ($file, $string);
#
#	search for $string into $file => 1 found / 0 not found

sub backupinstall
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	my $moddir = $_[3];
#	system "/bin/cp -p $wkdir/$file $storebkp/$file";
#	system "/bin/cp $moddir/$file $wkdir/$file";
	system "/bin/cp -p $moddir/$file $wkdir/$file";
}

sub backup
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	system "/bin/cp -p $wkdir/$file $storebkp/$file";
}

sub install
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $moddir = $_[2];
	system "/bin/cp -p $moddir/$file $wkdir/$file";
}

sub uninstallrestore
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	system "/bin/cp -p $storebkp/$file $wkdir/$file";
#	system "/bin/rm -f $storebkp/$file";
}

sub uninstall
{
	my $file = $_[0];
	my $wkdir = $_[1];
	system "/bin/rm -f $wkdir/$file";
}

sub easymod
{
	my $targetfile = $_[0];
	my $searchfile = $_[1];
	my $linestodelete = $_[2];
	my $replacefile = $_[3];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	open(SEARCH, "$searchfile") or die 'Unable to open search file';
	my @search = <SEARCH>;
	close(SEARCH);

	open(REPLACE, "$replacefile") or die 'Unable to open replace file.';
	my @replace = <REPLACE>;
	close(REPLACE);

	open(TEMP, ">/tmp/temp") or die 'Unable to open temporary file.';
	flock TEMP, 2;

	my $found = 0;
	my $line;
	foreach $line (@target)
	{
		if ($found == 0)
		{
			if ($line eq "@search")
			{
				$found = 1;
				if ($linestodelete > 0)
				{
					$linestodelete--;
				}
				else {print TEMP "$line"; }
				my $repline;
				foreach $repline (@replace) {print TEMP $repline; }
			}
			else {print TEMP "$line"; }
		}
		else
		{
			if ($linestodelete > 0)
			{
				$linestodelete--;
			}
			else {print TEMP "$line"; }
		}
	}	
	close(TEMP);
	system "/bin/cp /tmp/temp $targetfile";
	system "/bin/rm -f /tmp/temp";
}

sub installed
{
	my $targetfile = $_[0];
	my $searchstring = $_[1];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	my $line;
	foreach $line (@target)
	{
		if ($line eq "$searchstring\n")
		{
			return 1;
		}
	}	
	return 0;
}
