#!/usr/bin/perl
#
# Author: Matthew Yager
# Email: matty@dart.net.au
#
# Created: 2003 12 24
# Updated: 2004 01 05 - fixed test errors and report - MY
#
# dependent files /usr/local/bin/usage.dat
#


$filename = "/usr/local/bin/usage.dat";
$shscript = "/usr/local/bin/thisperiod.sh";

# set basic variables
$CurDate = (localtime(time()))[3];
$CurMonth = (localtime(time()))[4] + 1;
$CurYear = (localtime(time()))[5] + 1900;

$RepMonth = $CurMonth;
$RepYear = $CurYear;

# Set Anniversary Date
# read in file
open(FILE,"$filename") or die 'Unable to open config file.';
flock FILE, 2;
$Anniversarydate = <FILE>;
close(FILE);


#test the date also check month/year
if ($CurDate < $Anniversarydate)
{
	$RepMonth = $CurMonth -1;
	if ($RepMonth == 0)
	{
		$RepMonth = 12;
		$RepYear = $CurYear - 1;
	}
}

# Add leading zeros 
# set to null as if they are not needed the
# program still works and nothing is shown in the new script
$ZeroMonth;
$ZeroAvDate;

if ($RepMonth < 10)
{
	$ZeroMonth = 0;
}

if ($Anniversarydate< 10)
{
	$ZeroAvDate = 0;
}

#display some info
print "\n";
print "              Year Month Day \n";  
print "Today  is   : $CurYear  $CurMonth    $CurDate \n";
print "Report from : $RepYear  $ZeroMonth$RepMonth   $ZeroAvDate$Anniversarydate \n";

# write new script
open(FILE,">$shscript") or die 'Unable to open config file.';
flock FILE, 2;
print FILE "/usr/local/sbin/ipacsum --fixed-quantity M -starttime $RepYear$ZeroMonth$RepMonth$ZeroAvDate$Anniversarydate > /var/lib/ipac/ipacsum.thisperiod.stats";
close(FILE);
print "The script $shscript now updated!\n\n";

